////////////////////////////////////////////////////////////////////////////////
//                                                                      
//                        Fulladder Verilog Class Example
//  
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// MODULE:         tb_fulladder
//
// FILENAME:       tb_fulladder.v
// 
// DATE:           30. June 2000
//
// VERSION:        1.0
//
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// DESCRIPTION:    This is the testbench for the fulladder design.
//
//
////////////////////////////////////////////////////////////////////////////////
//
// REFERENCES:     (none)
//
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// CHANGES:        Version 2.0 - 30 June 2000
//
////////////////////////////////////////////////////////////////////////////////

  module tb_fulladder;

    reg a_i;
    reg b_i;
    reg cy_i;
    wire sum_o;
    wire cy_o;
  
    // Instantiate the fllfadder
    fulladder i_fulladder (.a_i(a_i), 
                           .b_i(b_i),
                           .cy_i(cy_i), 
                           .sum_o(sum_o), 
                           .cy_o(cy_o));

    initial
      begin
        // ZERO
        a_i = 1'b0;
        b_i = 1'b0;
        cy_i = 0;
        #100
        // ONE
        a_i = 1'b1;
        b_i = 1'b0;
        cy_i = 0;
        #100
        // TWO
        a_i = 1'b0;
        b_i = 1'b1;
        cy_i = 0;
        #100
        // THREE
        a_i = 1'b1;
        b_i = 1'b1;
        cy_i = 0;
        #100
        // FOUR
        a_i = 1'b0;
        b_i = 1'b0;
        cy_i = 1;
        #100
        // FIVE
        a_i = 1'b1;
        b_i = 1'b0;
        cy_i = 1;
        #100
        // SIX
        a_i = 1'b0;
        b_i = 1'b1;
        cy_i = 1;
        #100
        // SEVEN
        a_i = 1'b1;
        b_i = 1'b1;
        cy_i = 1;
        #100
        $finish; // This finishes the simulation!!       
      end
  
  endmodule                // tb_fulladder

