////////////////////////////////////////////////////////////////////////////////
//                                                                      
//                         Fulladder Verilog Class Example
//  
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// MODULE:         halfadder
//
// FILENAME:       halfadder.v
// 
// DATE:           30. June 2000
//
// VERSION:        1.0
//
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// DESCRIPTION:    This is the halfadder module of the fulladder design.
//
//
////////////////////////////////////////////////////////////////////////////////
//
// REFERENCES:     (none)
//
////////////////////////////////////////////////////////////////////////////////
//                                                                      
// CHANGES:        Version 2.0 - 30 June 2000
//
////////////////////////////////////////////////////////////////////////////////

  module halfadder (a_i, b_i, sum_o, cy_o);
    input a_i;              // first data bit
    input b_i;              // second data bit
    output sum_o;           // sum of the data bits
    output cy_o;            // carry output

    // These assign statements are reevaluated whenever an input changes.
    assign sum_o = a_i ^ b_i;
    assign cy_o = a_i & b_i;
  
  endmodule                // halfadder

